// przykadowy klient
public class OCFLoyalityClient 
{
    // AID apletu Loyality
    private static final byte[] LOYALITY_AID = ...

    public static void main(String[] argv) throws RemoteException 
    {
        try 
	{
            // aktywacja biblioteki OCF
            SmartCard.start();
            // oczekiwanie na kart
            CardRequest cr = new CardRequest(CardRequest.NEWCARD, null, 
					    OCFCardAccessor.class);
            SmartCard myCard = SmartCard.waitForCard(cr);
            // utworzenie instancji OCFCardAccessor dla Java Card RMI
            CardAccessor myCS = (CardAccessor) 
		myCard.getCardService(OCFCardAccessor.class, true);
            // utworzenie instancji Java Card RMI
            JavaCardRMIConnect jcRMI = new JavaCardRMIConnect(myCS);
	    // wybranie apletu 
            jcRMI.selectApplet(LOYALITY_AID);
            // referencja do obiektu na karcie
            Loyality loyalityApplet=(Loyality)jcRMI.getInitialReference();
            if (loyalityApplet == null) 
                throw new Exception("FAILED");

	    // wykonanie operacji odczytu iloci punktw z karty
            short points = loyalityApplet.read();
	    // dodanie punktw
            loyalityApplet.add((short) 200);
	    // odjcie punktw
            loyalityApplet.sub((short) 20);
	    // ponowne odczytanie iloci punktw
            points = loyalityApplet.read();
        } 
	catch (UserException e) 
	{
	    // wyjtek uytkownika (za operacja na punktach)
            e.printStackTrace();
        } 
	catch (Exception e) 
	{
	    // inne wyjtki
            System.out.println(e);
        } 
	finally 
	{
            try 
	    {
		// dezaktywacja biblioteki OCF
                SmartCard.shutdown();
            } 
	    catch (Exception e) 
	    {
                System.out.println(e);
            }
        }
    }
}

