// niezbdne pliki nagwkowe
#include <stdio.h>
#include <stdlib.h>

// plik nagwkowy biblioteki Smart Card ToolKit
#include "libsctk.h"

// wielko bufora
#define MAX_BUFFER_LEN 255

int main(void)
{
    // deskryptor poczenia
    struct sc_desc_s *sc;

    // bufor na dane
    char buffer[MAX_BUFFER_LEN];
    unsigned int len;

    // komenda GET CHALLENGE
    char GET_CHALLENGE[] = {0x00, 0x84, 0x00, 0x00, 0x08};
    
    // otwarcie urzdzenia podczonego do COM1 (/dev/ttyS1)
    sc = sctk_open("/dev/ttyS1", sc_prot_phoenix);

    if (!sc)
    {
	fprintf(stderr, "Bla: nie mozna otworzyc urzadzenia.\n");
	return -1;
    }

    // ustawienie czasu oczekiwania na odczyt danych
    sctk_setdelay(sc, sc_delay_timeout, 200000);

    // ustawienie konwencji gwnej przy przesyaniu danych
    sctk_command(sc, phs_command_direct_mode, 0);

    // zerowanie karty 
    sctk_reset(sc);

    // odczyt ATR
    memset(buffer, 0, MAX_BUFFER_LEN);
    len = sctk_read(sc, buffer, MAX_BUFFER_LEN);

    // brak odpowiedzi od karty
    if (len <= 0)
	printf("Brak ATR.\n");
    else
    {
	// odczytano ATR
	int i;
        printf("ATR [%i] =", len);
	for(i=0; i<len; ++i)
	    printf(" %x", buffer[i]);
    }

    // przesanie komendy do karty
    if (sctk_write(sc, GET_CHALLENGE, sizeof(GET_CHALLENGE)) 
	    != sizeof(GET_CHALLENGE))
        printf("Blad podczas przesylania danych.\n");
    else 
        printf("Przeslano komende GET_CHALLENGE.\n");
      
    // odczyt odpowiedzi 
    memset(buffer, 0, MAX_BUFFER_LEN);
    if ((len = sctk_read(sc, buffer, MAX_BUFFER_LEN)) <= 0)
	printf("Brak odpowiedzi od karty.\n");
    else
    {
	int i;
        printf("RAPDU [%i] =", len);
	for(i=0; i<len; ++i)
	    printf(" %x", buffer[i]);
    }

    // zamknicie urzdzenia 
    sctk_close(sc);

    return 0;
}
